# MAIN IMPORTS ================================================================================================================================================ #
from __future__ import with_statement
import psyco
psyco.full()
import es
import os
import gamethread
import random
# ============================================================================================================================================================= #

# * SAM IMPORTS
func = es.import_addon('sam/functions')

# '''''''''''''''''''' # Addon/Mod Info # '''''''''''''''''' #
addon = es.AddonInfo()
addon.name     = 'Adverts'
addon.basename = 'adverts'
addon.status   = 1
addon.version  = '1.1.pub'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# * VARIABLES

file    = 'cstrike/cfg/sam/adverts.txt'
lastmsg = None

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Addon State ###
	es.set('sam_' + addon.basename, 1)

	### Create CFG ###
	createFile()

	### Start Loop ###
	gamethread.delayedname(5, 'sam_adverts_loop', sendmsg, ())

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Addon State ###
	es.set('sam_' + addon.basename, 0)

	### Cancel Load Delay ###
	gamethread.cancelDelayed('sam_adverts_loop')

	### Popups ###
	func.popupDelete('rules')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def sendmsg():
	msg = random.choice(getAds())
	while msg == lastmsg: msg = random.choice(getAds())
	else: func.tell('#all', msg)
	gamethread.delayedname(30, 'sam_adverts_loop', sendmsg, ())

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def getAds():
	if os.path.isfile(file) == True:
		_list_ = []
		with open(file) as f:
			for line in f.readlines():
				if line.startswith('-') or line.startswith('- '): _list_.append(line.replace('- ', '').replace('-', ''))
		return _list_
	else: return []

# ============================================================================================================================================================= #
# ========================================================================= BLOCKS ============================================================================ #
# ============================================================================================================================================================= #
def createFile():
	if os.path.isfile(file) == False:
		f = open(file,'w')
		f.write('# - - - - - - - - - - - - - - - - - #\n')
		f.write('#  Source Admin Menu # Adverts file #\n')
		f.write('# - - - - - - - - - - - - - - - - - #\n')
		f.write('#\n')
		f.write('#  This file contains all your server advertisements.\n')
		f.write('#\n')
		f.write('#  To add an advert,\n')
		f.write('#  Start the line with a - and the message next to it.\n')
		f.write('#\n')
		f.write('#  # IMPORTANT NOTES:.\n')
		f.write('#  - You can use colors by following the examples below,\n')
		f.write('#    for more colors check the colors.txt file in cfg/sam folder.\n')
		f.write('#  - Messages will apear randomly every 45 seconds.\n')
		f.write('# \n')
		f.write('# - - - - - - - - - - - - - - - - - -\n')
		f.write(' \n')
		f.write('- #beigeWelcome to our server, have fun! :)\n')
		f.write('- #beigeNeed #cyanAdmins #beigehelp? Type #red!admins #beigeto see who is online.\n')
		f.write('- #redFriendly Fire #beigestatus? Type #red!ff #beigeto check it out.\n')
		f.write('- #redAlltalk #beigestatus? Type #red!alltalk #beigeto check it out.\n')
		f.write('- #beigeIf you like the server add it to favourites! :)\n')
		f.write('- #beigeBe nice and respect the server #red!rules#beige!\n')
		f.write('- #beigeAvoid fights, it is way better when everyone gets along\n')
		f.write('- #beigeWant to send a message to #cyanAdmins#beige only? Start typing with #red##beige.\n')

# ============================================================================================================================================================= #